/***************************************************************************
 *cr                                                                       
 *cr            (C) Copyright 1995 The Board of Trustees of the           
 *cr                        University of Illinois                       
 *cr                         All Rights Reserved                        
 *cr                                                                   
 ***************************************************************************/

/***************************************************************************
 * RCS INFORMATION:
 *
 *	$RCSfile: UNCTracker.h,v $
 *	$Author: billh $	$Locker:  $		$State: Exp $
 *	$Revision: 1.2 $	$Date: 95/03/24 18:52:34 $
 *
 ***************************************************************************
 * DESCRIPTION:
 *
 * A UNCTracker is a device for measuring the 3D spacial position of an input
 * device; it is a subclass of the Tracker class.
 *
 ***************************************************************************
 * REVISION HISTORY:
 *
 * $Log:	UNCTracker.h,v $
 * Revision 1.2  95/03/24  18:52:34  billh
 * Added copyright notice to top of file; made sure all virtual routines
 * are defined in the .C file, not in the .h file.
 * 
 * Revision 1.1  1994/09/03  11:18:18  dalke
 * Initial revision
 *
 * Revision 1.4  1994/04/20  23:08:33  billh
 * Fixed RCS header in files to include description; set most files to
 * include Global.h, and not ever main.h.  Global.h includes config.h and
 * utilities.h automatically, as well as Message.h for the output message
 * objects.
 *
 * Revision 1.3  1994/04/16  00:36:33  billh
 * Changed program name to vmd, added RCS header section.
 *
 ***************************************************************************/

#ifndef POLHEMUS_H
#define POLHEMUS_H

// project include files
#include "Tracker.h"
// UNC include files
extern "C" {
#include "tracker.h"
}

#define POL_MAXSENSORS	4


class UNCTracker : public Tracker {

private:
  
  // name of tracker
  t_name_type polName;

  // index for use with the UNC library
  t_index polIndex;

  // data structure for holding the data returned from the UNC library 
  t_report_type uncReport[POL_MAXSENSORS];

  // last return value from t_read
  int readRetval;

protected:
  // virtual routine which reads data from sensors, if available
  // returns TRUE if data read and variables changed, FALSE otherwise;
  virtual int my_get_data(int, float *, float *, float *, float *, int);

public:
  // constructors and destructors
  UNCTracker(char *name, int num_sensors = POL_MAXSENSORS);
  virtual ~UNCTracker(void);

};

#endif
